searchNodes=[{"doc":"Documentation for Factoid . Factoid is a library for generating test data using factories build on Ecto.Schemas. It's similar to ExMachina but it is not a drop-in replacement. Where ExMachina builds and keeps associations in the returned records, Factoid drops the associations and keeps the associated id fields. This opinionated approach helps building simpler tests. Installation Add factoid to the list of dependencies in mix.exs : def deps do [ { :factoid , &quot;~&gt; 0.1&quot; } ] end Usage Define a factory module that uses the Factoid behaviour, select the repo module, and define build/2 functions for each factory. def App.Factory do @behaviour Factoid use Factoid , repo : App.Repo alias App.Schemas.User alias App.Schemas.UserAvatar @impl Factoid def build ( factory , attrs \\\\ %{ } ) def build ( :user , attrs ) do % User { first_name : &quot;Jane&quot; , last_name : &quot;Doe&quot; , email_address : &quot;jane- \#{ unique_integer ( ) } @example.com&quot; , } |&gt; Map . merge ( attrs ) end def build ( :user_avatar , attrs ) do % UserAvatar { user : build ( :user ) } |&gt; Map . merge ( attrs ) end end In your tests you can import your factory and use it to create test data. def App.ModuleTest do use DataCase import App.Factory alias App.Repo alias App.Schemas.User test &quot;creates a user&quot; do user_1 = insert ( :user ) user_2 = insert ( :user , name : &quot;John&quot; ) assert user_1 != user_2 assert user_1 == Repo . get ( User , user_1 . id ) assert user_2 . name == &quot;John&quot; end end","ref":"Factoid.html","title":"Factoid","type":"behaviour"},{"doc":"Builds a record.","ref":"Factoid.html#c:build/1","title":"Factoid.build/1","type":"callback"},{"doc":"Builds a record with attributes.","ref":"Factoid.html#c:build/2","title":"Factoid.build/2","type":"callback"},{"doc":"Inserts a record with attributes.","ref":"Factoid.html#insert/4","title":"Factoid.insert/4","type":"function"},{"doc":"Generates a systemically unique integer.","ref":"Factoid.html#unique_integer/0","title":"Factoid.unique_integer/0","type":"function"},{"doc":"Generates a UUID.","ref":"Factoid.html#unique_uuid/0","title":"Factoid.unique_uuid/0","type":"function"},{"doc":"Documentation for Factoid . Factoid is a library for generating test data using factories build on Ecto.Schemas. It's similar to ExMachina but it is not a drop-in replacement. Where ExMachina builds and keeps associations in the returned records, Factoid drops the associations and keeps the associated id fields. This opinionated approach helps building simpler tests.","ref":"readme.html","title":"Factoid","type":"extras"},{"doc":"Add factoid to the list of dependencies in mix.exs : def deps do [ { :factoid , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Factoid - Installation","type":"extras"},{"doc":"Define a factory module that uses the Factoid behaviour, select the repo module, and define build/2 functions for each factory. def App.Factory do @behaviour Factoid use Factoid , repo : App.Repo alias App.Schemas.User alias App.Schemas.UserAvatar @impl Factoid def build ( factory , attrs \\\\ %{ } ) def build ( :user , attrs ) do % User { first_name : &quot;Jane&quot; , last_name : &quot;Doe&quot; , email_address : &quot;jane- \#{ unique_integer ( ) } @example.com&quot; , } |&gt; Map . merge ( attrs ) end def build ( :user_avatar , attrs ) do % UserAvatar { user : build ( :user ) } |&gt; Map . merge ( attrs ) end end In your tests you can import your factory and use it to create test data. def App.ModuleTest do use DataCase import App.Factory alias App.Repo alias App.Schemas.User test &quot;creates a user&quot; do user_1 = insert ( :user ) user_2 = insert ( :user , name : &quot;John&quot; ) assert user_1 != user_2 assert user_1 == Repo . get ( User , user_1 . id ) assert user_2 . name == &quot;John&quot; end end","ref":"readme.html#usage","title":"Factoid - Usage","type":"extras"}]